/* ccm-timeline.c generated by valac 0.16.0, the Vala compiler
 * generated from ccm-timeline.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * ccm-timeline.vala
 * Copyright (C) Nicolas Bruguier 2007-2011 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>


#define CCM_TYPE_TIMELINE_DIRECTION (ccm_timeline_direction_get_type ())

#define CCM_TYPE_TIMELINE (ccm_timeline_get_type ())
#define CCM_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_TIMELINE, CCMTimeline))
#define CCM_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_TIMELINE, CCMTimelineClass))
#define CCM_IS_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_TIMELINE))
#define CCM_IS_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_TIMELINE))
#define CCM_TIMELINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_TIMELINE, CCMTimelineClass))

typedef struct _CCMTimeline CCMTimeline;
typedef struct _CCMTimelineClass CCMTimelineClass;
typedef struct _CCMTimelinePrivate CCMTimelinePrivate;

#define CCM_TYPE_TIMEOUT (ccm_timeout_get_type ())
#define CCM_TIMEOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_TIMEOUT, CCMTimeout))
#define CCM_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_TIMEOUT, CCMTimeoutClass))
#define CCM_IS_TIMEOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_TIMEOUT))
#define CCM_IS_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_TIMEOUT))
#define CCM_TIMEOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_TIMEOUT, CCMTimeoutClass))

typedef struct _CCMTimeout CCMTimeout;
typedef struct _CCMTimeoutClass CCMTimeoutClass;

#define CCM_TYPE_TIMEOUT_POOL (ccm_timeout_pool_get_type ())
#define CCM_TIMEOUT_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_TIMEOUT_POOL, CCMTimeoutPool))
#define CCM_TIMEOUT_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_TIMEOUT_POOL, CCMTimeoutPoolClass))
#define CCM_IS_TIMEOUT_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_TIMEOUT_POOL))
#define CCM_IS_TIMEOUT_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_TIMEOUT_POOL))
#define CCM_TIMEOUT_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_TIMEOUT_POOL, CCMTimeoutPoolClass))

typedef struct _CCMTimeoutPool CCMTimeoutPool;
typedef struct _CCMTimeoutPoolClass CCMTimeoutPoolClass;
#define _ccm_timeout_unref0(var) ((var == NULL) ? NULL : (var = (ccm_timeout_unref (var), NULL)))
#define _ccm_timeout_pool_unref0(var) ((var == NULL) ? NULL : (var = (ccm_timeout_pool_unref (var), NULL)))

typedef enum  {
	CCM_TIMELINE_DIRECTION_FORWARD,
	CCM_TIMELINE_DIRECTION_BACKWARD
} CCMTimelineDirection;

struct _CCMTimeline {
	GObject parent_instance;
	CCMTimelinePrivate * priv;
};

struct _CCMTimelineClass {
	GObjectClass parent_class;
	void (*started) (CCMTimeline* self);
	void (*paused) (CCMTimeline* self);
	void (*new_frame) (CCMTimeline* self, gint inNumFrame);
	void (*completed) (CCMTimeline* self);
};

struct _CCMTimelinePrivate {
	CCMTimeout* m_Timeout;
	CCMTimelineDirection m_Direction;
	gint m_CurrentFrameNum;
	guint m_Fps;
	guint m_Duration;
	GTimeVal m_PrevFrameTimeVal;
	guint _n_frames;
	gboolean _master;
	gboolean _loop;
};

typedef gboolean (*CCMTimeoutFunc) (void* inData);

static gpointer ccm_timeline_parent_class = NULL;
static CCMTimeoutPool* ccm_timeline_s_TimeoutPool;
static CCMTimeoutPool* ccm_timeline_s_TimeoutPool = NULL;
static gboolean ccm_timeline_s_HaveDefault;
static gboolean ccm_timeline_s_HaveDefault = FALSE;
static gint ccm_timeline_s_DefaultPriority;
static gint ccm_timeline_s_DefaultPriority = 0;

GType ccm_timeline_direction_get_type (void) G_GNUC_CONST;
GType ccm_timeline_get_type (void) G_GNUC_CONST;
gpointer ccm_timeout_ref (gpointer instance);
void ccm_timeout_unref (gpointer instance);
GParamSpec* ccm_param_spec_timeout (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void ccm_value_set_timeout (GValue* value, gpointer v_object);
void ccm_value_take_timeout (GValue* value, gpointer v_object);
gpointer ccm_value_get_timeout (const GValue* value);
GType ccm_timeout_get_type (void) G_GNUC_CONST;
#define CCM_TIMELINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CCM_TYPE_TIMELINE, CCMTimelinePrivate))
enum  {
	CCM_TIMELINE_DUMMY_PROPERTY,
	CCM_TIMELINE_DIRECTION,
	CCM_TIMELINE_SPEED,
	CCM_TIMELINE_N_FRAMES,
	CCM_TIMELINE_DURATION,
	CCM_TIMELINE_MASTER,
	CCM_TIMELINE_LOOP,
	CCM_TIMELINE_IS_PLAYING,
	CCM_TIMELINE_CURRENT_FRAME,
	CCM_TIMELINE_PROGRESS
};
gpointer ccm_timeout_pool_ref (gpointer instance);
void ccm_timeout_pool_unref (gpointer instance);
GParamSpec* ccm_param_spec_timeout_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void ccm_value_set_timeout_pool (GValue* value, gpointer v_object);
void ccm_value_take_timeout_pool (GValue* value, gpointer v_object);
gpointer ccm_value_get_timeout_pool (const GValue* value);
GType ccm_timeout_pool_get_type (void) G_GNUC_CONST;
void ccm_timeout_pool_remove (CCMTimeoutPool* self, CCMTimeout* inTimeout);
void ccm_timeline_initialize (gint inPriority);
CCMTimeline* ccm_timeline_new (guint inNbFrames, guint inFps);
CCMTimeline* ccm_timeline_construct (GType object_type, guint inNbFrames, guint inFps);
CCMTimeline* ccm_timeline_new_for_duration (guint inDuration);
CCMTimeline* ccm_timeline_construct_for_duration (GType object_type, guint inDuration);
static void ccm_timeline_add_timeout (CCMTimeline* self);
gboolean ccm_timeline_get_master (CCMTimeline* self);
CCMTimeout* ccm_timeout_pool_add_master (CCMTimeoutPool* self, guint inFps, CCMTimeoutFunc inFunc, void* inData, GDestroyNotify inNotify);
static gboolean ccm_timeline_on_timeout (CCMTimeline* self);
static gboolean _ccm_timeline_on_timeout_ccm_timeout_func (void* inData);
CCMTimeout* ccm_timeout_pool_add (CCMTimeoutPool* self, guint inFps, CCMTimeoutFunc inFunc, void* inData, GDestroyNotify inNotify);
static inline gboolean ccm_timeline_is_complete (CCMTimeline* self);
guint ccm_timeline_get_n_frames (CCMTimeline* self);
gboolean ccm_timeline_get_loop (CCMTimeline* self);
void ccm_timeline_rewind (CCMTimeline* self);
void ccm_timeline_start (CCMTimeline* self);
void ccm_timeline_pause (CCMTimeline* self);
void ccm_timeline_stop (CCMTimeline* self);
void ccm_timeline_advance (CCMTimeline* self, guint inNumFrame);
void ccm_timeline_skip (CCMTimeline* self, gint inNbFrames);
void ccm_timeline_set_priority (gint inPriority);
void ccm_timeout_pool_set_priority (CCMTimeoutPool* self, gint inPriority);
CCMTimelineDirection ccm_timeline_get_direction (CCMTimeline* self);
void ccm_timeline_set_direction (CCMTimeline* self, CCMTimelineDirection value);
guint ccm_timeline_get_speed (CCMTimeline* self);
void ccm_timeline_set_speed (CCMTimeline* self, guint value);
void ccm_timeline_set_n_frames (CCMTimeline* self, guint value);
guint ccm_timeline_get_duration (CCMTimeline* self);
void ccm_timeline_set_duration (CCMTimeline* self, guint value);
void ccm_timeline_set_master (CCMTimeline* self, gboolean value);
void ccm_timeline_set_loop (CCMTimeline* self, gboolean value);
gboolean ccm_timeline_get_is_playing (CCMTimeline* self);
guint ccm_timeline_get_current_frame (CCMTimeline* self);
gdouble ccm_timeline_get_progress (CCMTimeline* self);
static void ccm_timeline_real_started (CCMTimeline* self);
static void ccm_timeline_real_paused (CCMTimeline* self);
static void ccm_timeline_real_new_frame (CCMTimeline* self, gint inNumFrame);
static void ccm_timeline_real_completed (CCMTimeline* self);
CCMTimeoutPool* ccm_timeout_pool_new (gint inPriority, GMainContext* inContext);
CCMTimeoutPool* ccm_timeout_pool_construct (GType object_type, gint inPriority, GMainContext* inContext);
static void ccm_timeline_finalize (GObject* obj);
static void _vala_ccm_timeline_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_ccm_timeline_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType ccm_timeline_direction_get_type (void) {
	static volatile gsize ccm_timeline_direction_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeline_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{CCM_TIMELINE_DIRECTION_FORWARD, "CCM_TIMELINE_DIRECTION_FORWARD", "forward"}, {CCM_TIMELINE_DIRECTION_BACKWARD, "CCM_TIMELINE_DIRECTION_BACKWARD", "backward"}, {0, NULL, NULL}};
		GType ccm_timeline_direction_type_id;
		ccm_timeline_direction_type_id = g_enum_register_static ("CCMTimelineDirection", values);
		g_once_init_leave (&ccm_timeline_direction_type_id__volatile, ccm_timeline_direction_type_id);
	}
	return ccm_timeline_direction_type_id__volatile;
}


void ccm_timeline_initialize (gint inPriority) {
	gint _tmp0_;
	_tmp0_ = inPriority;
	ccm_timeline_s_DefaultPriority = _tmp0_;
	ccm_timeline_s_HaveDefault = TRUE;
}


/**
     * Construct a new timeline
     *
     * @param inNbFrames number of frames
     * @param inFps timeline speed in frame per second
     */
CCMTimeline* ccm_timeline_construct (GType object_type, guint inNbFrames, guint inFps) {
	CCMTimeline * self = NULL;
	guint _tmp0_;
	guint _tmp1_;
	_tmp0_ = inFps;
	_tmp1_ = inNbFrames;
	self = (CCMTimeline*) g_object_new (object_type, "speed", _tmp0_, "n-frames", _tmp1_, NULL);
	return self;
}


CCMTimeline* ccm_timeline_new (guint inNbFrames, guint inFps) {
	return ccm_timeline_construct (CCM_TYPE_TIMELINE, inNbFrames, inFps);
}


/**
     * Construct a new timeline from duration
     *
     * @param inDuration timeline duration
     */
CCMTimeline* ccm_timeline_construct_for_duration (GType object_type, guint inDuration) {
	CCMTimeline * self = NULL;
	guint _tmp0_;
	_tmp0_ = inDuration;
	self = (CCMTimeline*) g_object_new (object_type, "duration", _tmp0_, NULL);
	return self;
}


CCMTimeline* ccm_timeline_new_for_duration (guint inDuration) {
	return ccm_timeline_construct_for_duration (CCM_TYPE_TIMELINE, inDuration);
}


static gboolean _ccm_timeline_on_timeout_ccm_timeout_func (void* inData) {
	gboolean result;
	result = ccm_timeline_on_timeout (inData);
	return result;
}


static void ccm_timeline_add_timeout (CCMTimeline* self) {
	GTimeVal _tmp0_;
	glong _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_PrevFrameTimeVal;
	_tmp1_ = _tmp0_.tv_sec;
	if (_tmp1_ == ((glong) 0)) {
		g_get_current_time (&self->priv->m_PrevFrameTimeVal);
	}
	_tmp2_ = self->priv->_master;
	if (_tmp2_) {
		CCMTimeoutPool* _tmp3_;
		guint _tmp4_;
		CCMTimeout* _tmp5_ = NULL;
		_tmp3_ = ccm_timeline_s_TimeoutPool;
		_tmp4_ = self->priv->m_Fps;
		_tmp5_ = ccm_timeout_pool_add_master (_tmp3_, _tmp4_, _ccm_timeline_on_timeout_ccm_timeout_func, self, NULL);
		_ccm_timeout_unref0 (self->priv->m_Timeout);
		self->priv->m_Timeout = _tmp5_;
	} else {
		CCMTimeoutPool* _tmp6_;
		guint _tmp7_;
		CCMTimeout* _tmp8_ = NULL;
		_tmp6_ = ccm_timeline_s_TimeoutPool;
		_tmp7_ = self->priv->m_Fps;
		_tmp8_ = ccm_timeout_pool_add (_tmp6_, _tmp7_, _ccm_timeline_on_timeout_ccm_timeout_func, self, NULL);
		_ccm_timeout_unref0 (self->priv->m_Timeout);
		self->priv->m_Timeout = _tmp8_;
	}
}


static inline gboolean ccm_timeline_is_complete (CCMTimeline* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	CCMTimelineDirection _tmp2_;
	gboolean _tmp5_;
	gboolean _tmp10_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp2_ = self->priv->m_Direction;
	if (_tmp2_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		gint _tmp3_;
		guint _tmp4_;
		_tmp3_ = self->priv->m_CurrentFrameNum;
		_tmp4_ = self->priv->_n_frames;
		_tmp1_ = ((guint) _tmp3_) >= _tmp4_;
	} else {
		_tmp1_ = FALSE;
	}
	_tmp5_ = _tmp1_;
	if (_tmp5_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		CCMTimelineDirection _tmp7_;
		gboolean _tmp9_;
		_tmp7_ = self->priv->m_Direction;
		if (_tmp7_ == CCM_TIMELINE_DIRECTION_BACKWARD) {
			gint _tmp8_;
			_tmp8_ = self->priv->m_CurrentFrameNum;
			_tmp6_ = _tmp8_ <= 0;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp9_ = _tmp6_;
		_tmp0_ = _tmp9_;
	}
	_tmp10_ = _tmp0_;
	result = _tmp10_;
	return result;
}


static gboolean ccm_timeline_on_timeout (CCMTimeline* self) {
	gboolean result = FALSE;
	GTimeVal now = {0};
	guint nb_frames = 0U;
	gulong msecs = 0UL;
	gulong speed = 0UL;
	GTimeVal _tmp0_;
	glong _tmp1_;
	GTimeVal _tmp3_;
	glong _tmp4_;
	GTimeVal _tmp5_;
	glong _tmp6_;
	GTimeVal _tmp8_;
	glong _tmp9_;
	GTimeVal _tmp10_;
	glong _tmp11_;
	gulong _tmp12_;
	GTimeVal _tmp13_;
	glong _tmp14_;
	GTimeVal _tmp15_;
	glong _tmp16_;
	guint _tmp17_;
	guint _tmp18_ = 0U;
	gulong _tmp19_;
	gulong _tmp20_;
	guint _tmp21_;
	GTimeVal _tmp22_;
	CCMTimelineDirection _tmp23_;
	gboolean _tmp28_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_get_current_time (&now);
	g_get_current_time (&now);
	_tmp0_ = self->priv->m_PrevFrameTimeVal;
	_tmp1_ = _tmp0_.tv_sec;
	if (_tmp1_ == ((glong) 0)) {
		GTimeVal _tmp2_;
		_tmp2_ = now;
		self->priv->m_PrevFrameTimeVal = _tmp2_;
	}
	_tmp3_ = now;
	_tmp4_ = _tmp3_.tv_sec;
	_tmp5_ = self->priv->m_PrevFrameTimeVal;
	_tmp6_ = _tmp5_.tv_sec;
	if ((_tmp4_ - _tmp6_) < ((glong) 0)) {
		GTimeVal _tmp7_;
		_tmp7_ = now;
		self->priv->m_PrevFrameTimeVal = _tmp7_;
	}
	_tmp8_ = now;
	_tmp9_ = _tmp8_.tv_sec;
	_tmp10_ = self->priv->m_PrevFrameTimeVal;
	_tmp11_ = _tmp10_.tv_sec;
	msecs = (gulong) ((_tmp9_ - _tmp11_) * 1000);
	_tmp12_ = msecs;
	_tmp13_ = now;
	_tmp14_ = _tmp13_.tv_usec;
	_tmp15_ = self->priv->m_PrevFrameTimeVal;
	_tmp16_ = _tmp15_.tv_usec;
	msecs = _tmp12_ + ((_tmp14_ - _tmp16_) / 1000);
	_tmp17_ = self->priv->m_Fps;
	_tmp18_ = MAX (1000 / _tmp17_, (guint) 1);
	speed = (gulong) _tmp18_;
	_tmp19_ = msecs;
	_tmp20_ = speed;
	nb_frames = (guint) (_tmp19_ / _tmp20_);
	_tmp21_ = nb_frames;
	if (_tmp21_ == ((guint) 0)) {
		nb_frames = (guint) 1;
	}
	_tmp22_ = now;
	self->priv->m_PrevFrameTimeVal = _tmp22_;
	_tmp23_ = self->priv->m_Direction;
	if (_tmp23_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		gint _tmp24_;
		guint _tmp25_;
		_tmp24_ = self->priv->m_CurrentFrameNum;
		_tmp25_ = nb_frames;
		self->priv->m_CurrentFrameNum = _tmp24_ + ((gint) _tmp25_);
	} else {
		gint _tmp26_;
		guint _tmp27_;
		_tmp26_ = self->priv->m_CurrentFrameNum;
		_tmp27_ = nb_frames;
		self->priv->m_CurrentFrameNum = _tmp26_ - ((gint) _tmp27_);
	}
	_tmp28_ = ccm_timeline_is_complete (self);
	if (!_tmp28_) {
		gint _tmp29_;
		CCMTimeout* _tmp30_;
		_tmp29_ = self->priv->m_CurrentFrameNum;
		g_signal_emit_by_name (self, "new-frame", _tmp29_);
		_tmp30_ = self->priv->m_Timeout;
		if (_tmp30_ == NULL) {
			result = FALSE;
			return result;
		}
		result = TRUE;
		return result;
	} else {
		CCMTimelineDirection _tmp31_;
		CCMTimelineDirection saved_direction;
		gint _tmp32_;
		guint overflow_frame_num;
		gint end_frame = 0;
		CCMTimelineDirection _tmp33_;
		gint _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		gboolean _tmp40_ = FALSE;
		gboolean _tmp41_;
		gboolean _tmp43_;
		gboolean _tmp46_ = FALSE;
		gint _tmp47_;
		gint _tmp48_;
		gboolean _tmp61_;
		gboolean _tmp62_;
		_tmp31_ = self->priv->m_Direction;
		saved_direction = _tmp31_;
		_tmp32_ = self->priv->m_CurrentFrameNum;
		overflow_frame_num = (guint) _tmp32_;
		_tmp33_ = self->priv->m_Direction;
		if (_tmp33_ == CCM_TIMELINE_DIRECTION_FORWARD) {
			guint _tmp34_;
			_tmp34_ = self->priv->_n_frames;
			self->priv->m_CurrentFrameNum = (gint) _tmp34_;
		} else {
			CCMTimelineDirection _tmp35_;
			_tmp35_ = self->priv->m_Direction;
			if (_tmp35_ == CCM_TIMELINE_DIRECTION_BACKWARD) {
				self->priv->m_CurrentFrameNum = 0;
			}
		}
		_tmp36_ = self->priv->m_CurrentFrameNum;
		end_frame = _tmp36_;
		_tmp37_ = self->priv->m_CurrentFrameNum;
		g_signal_emit_by_name (self, "new-frame", _tmp37_);
		_tmp38_ = self->priv->m_CurrentFrameNum;
		_tmp39_ = end_frame;
		if (_tmp38_ != _tmp39_) {
			result = TRUE;
			return result;
		}
		_tmp41_ = self->priv->_loop;
		if (!_tmp41_) {
			CCMTimeout* _tmp42_;
			_tmp42_ = self->priv->m_Timeout;
			_tmp40_ = _tmp42_ != NULL;
		} else {
			_tmp40_ = FALSE;
		}
		_tmp43_ = _tmp40_;
		if (_tmp43_) {
			CCMTimeoutPool* _tmp44_;
			CCMTimeout* _tmp45_;
			_tmp44_ = ccm_timeline_s_TimeoutPool;
			_tmp45_ = self->priv->m_Timeout;
			ccm_timeout_pool_remove (_tmp44_, _tmp45_);
			_ccm_timeout_unref0 (self->priv->m_Timeout);
			self->priv->m_Timeout = NULL;
		}
		g_signal_emit_by_name (self, "completed");
		_tmp47_ = self->priv->m_CurrentFrameNum;
		_tmp48_ = end_frame;
		if (_tmp47_ != _tmp48_) {
			gboolean _tmp49_ = FALSE;
			gboolean _tmp50_ = FALSE;
			gint _tmp51_;
			gboolean _tmp54_;
			gboolean _tmp60_;
			_tmp51_ = self->priv->m_CurrentFrameNum;
			if (_tmp51_ == 0) {
				gint _tmp52_;
				guint _tmp53_;
				_tmp52_ = end_frame;
				_tmp53_ = self->priv->_n_frames;
				_tmp50_ = ((guint) _tmp52_) == _tmp53_;
			} else {
				_tmp50_ = FALSE;
			}
			_tmp54_ = _tmp50_;
			if (_tmp54_) {
				_tmp49_ = TRUE;
			} else {
				gboolean _tmp55_ = FALSE;
				gint _tmp56_;
				guint _tmp57_;
				gboolean _tmp59_;
				_tmp56_ = self->priv->m_CurrentFrameNum;
				_tmp57_ = self->priv->_n_frames;
				if (((guint) _tmp56_) == _tmp57_) {
					gint _tmp58_;
					_tmp58_ = end_frame;
					_tmp55_ = _tmp58_ == 0;
				} else {
					_tmp55_ = FALSE;
				}
				_tmp59_ = _tmp55_;
				_tmp49_ = _tmp59_;
			}
			_tmp60_ = _tmp49_;
			_tmp46_ = !_tmp60_;
		} else {
			_tmp46_ = FALSE;
		}
		_tmp61_ = _tmp46_;
		if (_tmp61_) {
			result = TRUE;
			return result;
		}
		_tmp62_ = self->priv->_loop;
		if (_tmp62_) {
			CCMTimelineDirection _tmp63_;
			CCMTimelineDirection _tmp68_;
			CCMTimelineDirection _tmp69_;
			_tmp63_ = saved_direction;
			if (_tmp63_ == CCM_TIMELINE_DIRECTION_FORWARD) {
				guint _tmp64_;
				guint _tmp65_;
				_tmp64_ = overflow_frame_num;
				_tmp65_ = self->priv->_n_frames;
				self->priv->m_CurrentFrameNum = (gint) (_tmp64_ - _tmp65_);
			} else {
				guint _tmp66_;
				guint _tmp67_;
				_tmp66_ = self->priv->_n_frames;
				_tmp67_ = overflow_frame_num;
				self->priv->m_CurrentFrameNum = (gint) (_tmp66_ + _tmp67_);
			}
			_tmp68_ = self->priv->m_Direction;
			_tmp69_ = saved_direction;
			if (_tmp68_ != _tmp69_) {
				guint _tmp70_;
				gint _tmp71_;
				_tmp70_ = self->priv->_n_frames;
				_tmp71_ = self->priv->m_CurrentFrameNum;
				self->priv->m_CurrentFrameNum = (gint) (_tmp70_ - _tmp71_);
			}
			result = TRUE;
			return result;
		} else {
			ccm_timeline_rewind (self);
			self->priv->m_PrevFrameTimeVal.tv_sec = (glong) 0;
			self->priv->m_PrevFrameTimeVal.tv_usec = (glong) 0;
			result = FALSE;
			return result;
		}
	}
}


/**
     * Start timeline
     */
void ccm_timeline_start (CCMTimeline* self) {
	guint _tmp0_;
	CCMTimeout* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_n_frames;
	g_return_if_fail (_tmp0_ > ((guint) 0));
	_tmp1_ = self->priv->m_Timeout;
	if (_tmp1_ != NULL) {
		return;
	}
	ccm_timeline_add_timeout (self);
	g_signal_emit_by_name (self, "started");
}


/**
     * Pause timeline
     */
void ccm_timeline_pause (CCMTimeline* self) {
	CCMTimeout* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_Timeout;
	if (_tmp0_ != NULL) {
		CCMTimeoutPool* _tmp1_;
		CCMTimeout* _tmp2_;
		_tmp1_ = ccm_timeline_s_TimeoutPool;
		_tmp2_ = self->priv->m_Timeout;
		ccm_timeout_pool_remove (_tmp1_, _tmp2_);
		_ccm_timeout_unref0 (self->priv->m_Timeout);
		self->priv->m_Timeout = NULL;
	}
	self->priv->m_PrevFrameTimeVal.tv_sec = (glong) 0;
	self->priv->m_PrevFrameTimeVal.tv_usec = (glong) 0;
	g_signal_emit_by_name (self, "paused");
}


/**
     * Stop timeline
     */
void ccm_timeline_stop (CCMTimeline* self) {
	g_return_if_fail (self != NULL);
	ccm_timeline_pause (self);
	ccm_timeline_rewind (self);
}


/**
     * Rewind timeline to begining
     */
void ccm_timeline_rewind (CCMTimeline* self) {
	CCMTimelineDirection _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_Direction;
	if (_tmp0_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		ccm_timeline_advance (self, (guint) 0);
	} else {
		CCMTimelineDirection _tmp1_;
		_tmp1_ = self->priv->m_Direction;
		if (_tmp1_ == CCM_TIMELINE_DIRECTION_BACKWARD) {
			guint _tmp2_;
			_tmp2_ = self->priv->_n_frames;
			ccm_timeline_advance (self, _tmp2_);
		}
	}
}


/**
     * Advance timeline to frame inNumFrame
     *
     * @param inNFrames frame number to advance to
     */
void ccm_timeline_advance (CCMTimeline* self, guint inNumFrame) {
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = inNumFrame;
	_tmp1_ = self->priv->_n_frames;
	_tmp2_ = CLAMP (_tmp0_, (guint) 0, _tmp1_);
	self->priv->m_CurrentFrameNum = (gint) _tmp2_;
}


/**
     * Skip inNbFrames 
     *
     * @param inNbFrames number of frames to skip
     */
void ccm_timeline_skip (CCMTimeline* self, gint inNbFrames) {
	CCMTimelineDirection _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_Direction;
	if (_tmp0_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		guint _tmp4_;
		_tmp1_ = self->priv->m_CurrentFrameNum;
		_tmp2_ = inNbFrames;
		self->priv->m_CurrentFrameNum = _tmp1_ + _tmp2_;
		_tmp3_ = self->priv->m_CurrentFrameNum;
		_tmp4_ = self->priv->_n_frames;
		if (((guint) _tmp3_) > _tmp4_) {
			self->priv->m_CurrentFrameNum = 1;
		}
	} else {
		CCMTimelineDirection _tmp5_;
		_tmp5_ = self->priv->m_Direction;
		if (_tmp5_ == CCM_TIMELINE_DIRECTION_BACKWARD) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			_tmp6_ = self->priv->m_CurrentFrameNum;
			_tmp7_ = inNbFrames;
			self->priv->m_CurrentFrameNum = _tmp6_ - _tmp7_;
			_tmp8_ = self->priv->m_CurrentFrameNum;
			if (_tmp8_ < 1) {
				guint _tmp9_;
				_tmp9_ = self->priv->_n_frames;
				self->priv->m_CurrentFrameNum = (gint) (_tmp9_ - 1);
			}
		}
	}
}


/**
     * Set timeline timeout pool priority
     *
     * @param inPriority timeout pool priority
     */
void ccm_timeline_set_priority (gint inPriority) {
	CCMTimeoutPool* _tmp0_;
	gint _tmp1_;
	_tmp0_ = ccm_timeline_s_TimeoutPool;
	_tmp1_ = inPriority;
	ccm_timeout_pool_set_priority (_tmp0_, _tmp1_);
}


CCMTimelineDirection ccm_timeline_get_direction (CCMTimeline* self) {
	CCMTimelineDirection result;
	CCMTimelineDirection _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->m_Direction;
	result = _tmp0_;
	return result;
}


void ccm_timeline_set_direction (CCMTimeline* self, CCMTimelineDirection value) {
	CCMTimelineDirection _tmp0_;
	CCMTimelineDirection _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_Direction;
	_tmp1_ = value;
	if (_tmp0_ != _tmp1_) {
		CCMTimelineDirection _tmp2_;
		gint _tmp3_;
		_tmp2_ = value;
		self->priv->m_Direction = _tmp2_;
		_tmp3_ = self->priv->m_CurrentFrameNum;
		if (_tmp3_ == 0) {
			guint _tmp4_;
			_tmp4_ = self->priv->_n_frames;
			self->priv->m_CurrentFrameNum = (gint) _tmp4_;
		}
	}
	g_object_notify ((GObject *) self, "direction");
}


guint ccm_timeline_get_speed (CCMTimeline* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->m_Fps;
	result = _tmp0_;
	return result;
}


void ccm_timeline_set_speed (CCMTimeline* self, guint value) {
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_Fps;
	_tmp1_ = value;
	if (_tmp0_ != _tmp1_) {
		guint _tmp2_;
		CCMTimeout* _tmp3_;
		_tmp2_ = value;
		self->priv->m_Fps = _tmp2_;
		_tmp3_ = self->priv->m_Timeout;
		if (_tmp3_ != NULL) {
			CCMTimeoutPool* _tmp4_;
			CCMTimeout* _tmp5_;
			_tmp4_ = ccm_timeline_s_TimeoutPool;
			_tmp5_ = self->priv->m_Timeout;
			ccm_timeout_pool_remove (_tmp4_, _tmp5_);
			ccm_timeline_add_timeout (self);
		}
	}
	g_object_notify ((GObject *) self, "speed");
}


guint ccm_timeline_get_n_frames (CCMTimeline* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_n_frames;
	result = _tmp0_;
	return result;
}


void ccm_timeline_set_n_frames (CCMTimeline* self, guint value) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_n_frames = _tmp0_;
	g_object_notify ((GObject *) self, "n-frames");
}


guint ccm_timeline_get_duration (CCMTimeline* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->m_Duration;
	result = _tmp0_;
	return result;
}


void ccm_timeline_set_duration (CCMTimeline* self, guint value) {
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_Duration;
	_tmp1_ = value;
	if (_tmp0_ != _tmp1_) {
		guint _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		_tmp2_ = value;
		self->priv->m_Duration = _tmp2_;
		_tmp3_ = self->priv->m_Duration;
		_tmp4_ = self->priv->m_Fps;
		ccm_timeline_set_n_frames (self, (_tmp3_ * _tmp4_) / 1000);
	}
	g_object_notify ((GObject *) self, "duration");
}


gboolean ccm_timeline_get_master (CCMTimeline* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_master;
	result = _tmp0_;
	return result;
}


void ccm_timeline_set_master (CCMTimeline* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_master = _tmp0_;
	g_object_notify ((GObject *) self, "master");
}


gboolean ccm_timeline_get_loop (CCMTimeline* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_loop;
	result = _tmp0_;
	return result;
}


void ccm_timeline_set_loop (CCMTimeline* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_loop = _tmp0_;
	g_object_notify ((GObject *) self, "loop");
}


gboolean ccm_timeline_get_is_playing (CCMTimeline* self) {
	gboolean result;
	CCMTimeout* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_Timeout;
	result = _tmp0_ != NULL;
	return result;
}


guint ccm_timeline_get_current_frame (CCMTimeline* self) {
	guint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->m_CurrentFrameNum;
	result = (guint) _tmp0_;
	return result;
}


gdouble ccm_timeline_get_progress (CCMTimeline* self) {
	gdouble result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp3_;
	guint _tmp4_;
	gdouble _tmp5_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = ccm_timeline_get_is_playing (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		CCMTimelineDirection _tmp2_;
		_tmp2_ = self->priv->m_Direction;
		if (_tmp2_ == CCM_TIMELINE_DIRECTION_FORWARD) {
			result = 0.0;
			return result;
		} else {
			result = 1.0;
			return result;
		}
	}
	_tmp3_ = self->priv->m_CurrentFrameNum;
	_tmp4_ = self->priv->_n_frames;
	_tmp5_ = CLAMP (((gdouble) _tmp3_) / ((gdouble) _tmp4_), 0.0, 1.0);
	result = _tmp5_;
	return result;
}


static void ccm_timeline_real_started (CCMTimeline* self) {
}


static void ccm_timeline_real_paused (CCMTimeline* self) {
}


static void ccm_timeline_real_new_frame (CCMTimeline* self, gint inNumFrame) {
}


static void ccm_timeline_real_completed (CCMTimeline* self) {
}


static void ccm_timeline_class_init (CCMTimelineClass * klass) {
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gint _tmp3_;
	CCMTimeoutPool* _tmp4_;
	ccm_timeline_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CCMTimelinePrivate));
	CCM_TIMELINE_CLASS (klass)->started = ccm_timeline_real_started;
	CCM_TIMELINE_CLASS (klass)->paused = ccm_timeline_real_paused;
	CCM_TIMELINE_CLASS (klass)->new_frame = ccm_timeline_real_new_frame;
	CCM_TIMELINE_CLASS (klass)->completed = ccm_timeline_real_completed;
	G_OBJECT_CLASS (klass)->get_property = _vala_ccm_timeline_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_ccm_timeline_set_property;
	G_OBJECT_CLASS (klass)->finalize = ccm_timeline_finalize;
	/**
	     * Timeline direction
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_DIRECTION, g_param_spec_enum ("direction", "direction", "direction", CCM_TYPE_TIMELINE_DIRECTION, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Timeline speed in frame per second
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_SPEED, g_param_spec_uint ("speed", "speed", "speed", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Number of frame in Timeline 
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_N_FRAMES, g_param_spec_uint ("n-frames", "n-frames", "n-frames", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Timeline duration in msecs
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_DURATION, g_param_spec_uint ("duration", "duration", "duration", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Indicate if timeline is master timeline
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_MASTER, g_param_spec_boolean ("master", "master", "master", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Timeline loop
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_LOOP, g_param_spec_boolean ("loop", "loop", "loop", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Indicate if timeline is currently running
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_IS_PLAYING, g_param_spec_boolean ("is-playing", "is-playing", "is-playing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Current frame
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_CURRENT_FRAME, g_param_spec_uint ("current-frame", "current-frame", "current-frame", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Timeline progress 
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_PROGRESS, g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("started", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (CCMTimelineClass, started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("paused", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (CCMTimelineClass, paused), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("new_frame", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (CCMTimelineClass, new_frame), NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_signal_new ("completed", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (CCMTimelineClass, completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp1_ = ccm_timeline_s_HaveDefault;
	if (_tmp1_) {
		gint _tmp2_;
		_tmp2_ = ccm_timeline_s_DefaultPriority;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = G_PRIORITY_DEFAULT + 10;
	}
	_tmp3_ = _tmp0_;
	_tmp4_ = ccm_timeout_pool_new (_tmp3_, NULL);
	_ccm_timeout_pool_unref0 (ccm_timeline_s_TimeoutPool);
	ccm_timeline_s_TimeoutPool = _tmp4_;
}


static void ccm_timeline_instance_init (CCMTimeline * self) {
	self->priv = CCM_TIMELINE_GET_PRIVATE (self);
	self->priv->m_Timeout = NULL;
	self->priv->m_Direction = CCM_TIMELINE_DIRECTION_FORWARD;
	self->priv->m_CurrentFrameNum = 0;
	self->priv->m_Fps = (guint) 60;
	self->priv->m_Duration = (guint) 0;
	self->priv->_n_frames = (guint) 0;
	self->priv->_master = FALSE;
	self->priv->_loop = FALSE;
}


static void ccm_timeline_finalize (GObject* obj) {
	CCMTimeline * self;
	CCMTimeout* _tmp0_;
	self = CCM_TIMELINE (obj);
	_tmp0_ = self->priv->m_Timeout;
	if (_tmp0_ != NULL) {
		CCMTimeoutPool* _tmp1_;
		CCMTimeout* _tmp2_;
		_tmp1_ = ccm_timeline_s_TimeoutPool;
		_tmp2_ = self->priv->m_Timeout;
		ccm_timeout_pool_remove (_tmp1_, _tmp2_);
	}
	_ccm_timeout_unref0 (self->priv->m_Timeout);
	G_OBJECT_CLASS (ccm_timeline_parent_class)->finalize (obj);
}


GType ccm_timeline_get_type (void) {
	static volatile gsize ccm_timeline_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeline_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CCMTimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ccm_timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CCMTimeline), 0, (GInstanceInitFunc) ccm_timeline_instance_init, NULL };
		GType ccm_timeline_type_id;
		ccm_timeline_type_id = g_type_register_static (G_TYPE_OBJECT, "CCMTimeline", &g_define_type_info, 0);
		g_once_init_leave (&ccm_timeline_type_id__volatile, ccm_timeline_type_id);
	}
	return ccm_timeline_type_id__volatile;
}


static void _vala_ccm_timeline_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CCMTimeline * self;
	self = CCM_TIMELINE (object);
	switch (property_id) {
		case CCM_TIMELINE_DIRECTION:
		g_value_set_enum (value, ccm_timeline_get_direction (self));
		break;
		case CCM_TIMELINE_SPEED:
		g_value_set_uint (value, ccm_timeline_get_speed (self));
		break;
		case CCM_TIMELINE_N_FRAMES:
		g_value_set_uint (value, ccm_timeline_get_n_frames (self));
		break;
		case CCM_TIMELINE_DURATION:
		g_value_set_uint (value, ccm_timeline_get_duration (self));
		break;
		case CCM_TIMELINE_MASTER:
		g_value_set_boolean (value, ccm_timeline_get_master (self));
		break;
		case CCM_TIMELINE_LOOP:
		g_value_set_boolean (value, ccm_timeline_get_loop (self));
		break;
		case CCM_TIMELINE_IS_PLAYING:
		g_value_set_boolean (value, ccm_timeline_get_is_playing (self));
		break;
		case CCM_TIMELINE_CURRENT_FRAME:
		g_value_set_uint (value, ccm_timeline_get_current_frame (self));
		break;
		case CCM_TIMELINE_PROGRESS:
		g_value_set_double (value, ccm_timeline_get_progress (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_ccm_timeline_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CCMTimeline * self;
	self = CCM_TIMELINE (object);
	switch (property_id) {
		case CCM_TIMELINE_DIRECTION:
		ccm_timeline_set_direction (self, g_value_get_enum (value));
		break;
		case CCM_TIMELINE_SPEED:
		ccm_timeline_set_speed (self, g_value_get_uint (value));
		break;
		case CCM_TIMELINE_N_FRAMES:
		ccm_timeline_set_n_frames (self, g_value_get_uint (value));
		break;
		case CCM_TIMELINE_DURATION:
		ccm_timeline_set_duration (self, g_value_get_uint (value));
		break;
		case CCM_TIMELINE_MASTER:
		ccm_timeline_set_master (self, g_value_get_boolean (value));
		break;
		case CCM_TIMELINE_LOOP:
		ccm_timeline_set_loop (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



