/* ccm-timeout-interval.c generated by valac 0.16.0, the Vala compiler
 * generated from ccm-timeout-interval.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * ccm-timeout-interval.vala
 * Copyright (C) Nicolas Bruguier 2007-2011 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>


#define CCM_TYPE_TIMEOUT_INTERVAL (ccm_timeout_interval_get_type ())
typedef struct _CCMTimeoutInterval CCMTimeoutInterval;

typedef gboolean (*CCMTimeoutFunc) (void* inData);
struct _CCMTimeoutInterval {
	GTimeVal m_StartTime;
	guint m_FrameCount;
	guint m_Fps;
};



GType ccm_timeout_interval_get_type (void) G_GNUC_CONST;
CCMTimeoutInterval* ccm_timeout_interval_dup (const CCMTimeoutInterval* self);
void ccm_timeout_interval_free (CCMTimeoutInterval* self);
void ccm_timeout_interval_init (CCMTimeoutInterval *self, guint inFps);
static inline gulong ccm_timeout_interval_get_ticks (CCMTimeoutInterval *self, GTimeVal* inCurrentTime);
gboolean ccm_timeout_interval_prepare (CCMTimeoutInterval *self, GTimeVal* inCurrentTime, gint* outDelay);
gboolean ccm_timeout_interval_dispatch (CCMTimeoutInterval *self, CCMTimeoutFunc inCallback, void* inData);
gint ccm_timeout_interval_compare (CCMTimeoutInterval *self, CCMTimeoutInterval* inTimeoutInterval);


void ccm_timeout_interval_init (CCMTimeoutInterval *self, guint inFps) {
	guint _tmp0_;
	memset (self, 0, sizeof (CCMTimeoutInterval));
	g_get_current_time (&(*self).m_StartTime);
	_tmp0_ = inFps;
	(*self).m_Fps = _tmp0_;
	(*self).m_FrameCount = (guint) 0;
}


static inline gulong ccm_timeout_interval_get_ticks (CCMTimeoutInterval *self, GTimeVal* inCurrentTime) {
	gulong result = 0UL;
	GTimeVal _tmp0_;
	glong _tmp1_;
	GTimeVal _tmp2_;
	glong _tmp3_;
	GTimeVal _tmp4_;
	glong _tmp5_;
	GTimeVal _tmp6_;
	glong _tmp7_;
	g_return_val_if_fail (inCurrentTime != NULL, 0UL);
	_tmp0_ = *inCurrentTime;
	_tmp1_ = _tmp0_.tv_sec;
	_tmp2_ = (*self).m_StartTime;
	_tmp3_ = _tmp2_.tv_sec;
	_tmp4_ = *inCurrentTime;
	_tmp5_ = _tmp4_.tv_usec;
	_tmp6_ = (*self).m_StartTime;
	_tmp7_ = _tmp6_.tv_usec;
	result = (gulong) (((_tmp1_ - _tmp3_) * 1000) + ((_tmp5_ - _tmp7_) / 1000));
	return result;
}


gboolean ccm_timeout_interval_prepare (CCMTimeoutInterval *self, GTimeVal* inCurrentTime, gint* outDelay) {
	gint _vala_outDelay = 0;
	gboolean result = FALSE;
	gboolean ret;
	GTimeVal _tmp0_;
	gulong _tmp1_ = 0UL;
	gulong elapsed_time;
	gulong _tmp2_;
	guint _tmp3_;
	guint new_frame_num;
	gboolean _tmp4_ = FALSE;
	guint _tmp5_;
	guint _tmp6_;
	gboolean _tmp9_;
	g_return_val_if_fail (inCurrentTime != NULL, FALSE);
	ret = FALSE;
	_tmp0_ = *inCurrentTime;
	_tmp1_ = ccm_timeout_interval_get_ticks (&(*self), &_tmp0_);
	elapsed_time = _tmp1_;
	_tmp2_ = elapsed_time;
	_tmp3_ = (*self).m_Fps;
	new_frame_num = (guint) ((_tmp2_ * _tmp3_) / 1000);
	_tmp5_ = new_frame_num;
	_tmp6_ = (*self).m_FrameCount;
	if (_tmp5_ < _tmp6_) {
		_tmp4_ = TRUE;
	} else {
		guint _tmp7_;
		guint _tmp8_;
		_tmp7_ = new_frame_num;
		_tmp8_ = (*self).m_FrameCount;
		_tmp4_ = (_tmp7_ - _tmp8_) > ((guint) 2);
	}
	_tmp9_ = _tmp4_;
	if (_tmp9_) {
		guint _tmp10_;
		guint _tmp11_;
		glong frame_time;
		GTimeVal _tmp12_;
		glong _tmp13_;
		_tmp10_ = (*self).m_Fps;
		_tmp11_ = (*self).m_Fps;
		frame_time = (glong) (((1000 + _tmp10_) - 1) / _tmp11_);
		_tmp12_ = *inCurrentTime;
		(*self).m_StartTime = _tmp12_;
		_tmp13_ = frame_time;
		g_time_val_add (&(*self).m_StartTime, (-_tmp13_) * 1000);
		(*self).m_FrameCount = (guint) 0;
		_vala_outDelay = 0;
		ret = TRUE;
	} else {
		guint _tmp14_;
		guint _tmp15_;
		_tmp14_ = new_frame_num;
		_tmp15_ = (*self).m_FrameCount;
		if (_tmp14_ > _tmp15_) {
			_vala_outDelay = 0;
			ret = TRUE;
		} else {
			guint _tmp16_;
			guint _tmp17_;
			gulong _tmp18_;
			_tmp16_ = (*self).m_FrameCount;
			_tmp17_ = (*self).m_Fps;
			_tmp18_ = elapsed_time;
			_vala_outDelay = (gint) ((((_tmp16_ + 1) * 1000) / _tmp17_) - _tmp18_);
		}
	}
	result = ret;
	if (outDelay) {
		*outDelay = _vala_outDelay;
	}
	return result;
}


gboolean ccm_timeout_interval_dispatch (CCMTimeoutInterval *self, CCMTimeoutFunc inCallback, void* inData) {
	gboolean result = FALSE;
	gboolean ret;
	CCMTimeoutFunc _tmp0_;
	void* _tmp1_;
	gboolean _tmp2_ = FALSE;
	ret = FALSE;
	_tmp0_ = inCallback;
	_tmp1_ = inData;
	_tmp2_ = _tmp0_ (_tmp1_);
	if (_tmp2_) {
		guint _tmp3_;
		_tmp3_ = (*self).m_FrameCount;
		(*self).m_FrameCount = _tmp3_ + 1;
		ret = TRUE;
	}
	result = ret;
	return result;
}


gint ccm_timeout_interval_compare (CCMTimeoutInterval *self, CCMTimeoutInterval* inTimeoutInterval) {
	gint result = 0;
	guint _tmp0_;
	glong a_delay;
	CCMTimeoutInterval _tmp1_;
	guint _tmp2_;
	glong b_delay;
	glong b_difference = 0L;
	GTimeVal _tmp3_;
	glong _tmp4_;
	CCMTimeoutInterval _tmp5_;
	GTimeVal _tmp6_;
	glong _tmp7_;
	GTimeVal _tmp8_;
	glong _tmp9_;
	CCMTimeoutInterval _tmp10_;
	GTimeVal _tmp11_;
	glong _tmp12_;
	guint _tmp13_;
	CCMTimeoutInterval _tmp14_;
	guint _tmp15_;
	g_return_val_if_fail (inTimeoutInterval != NULL, 0);
	_tmp0_ = (*self).m_Fps;
	a_delay = (glong) (1000 / _tmp0_);
	_tmp1_ = *inTimeoutInterval;
	_tmp2_ = _tmp1_.m_Fps;
	b_delay = (glong) (1000 / _tmp2_);
	_tmp3_ = (*self).m_StartTime;
	_tmp4_ = _tmp3_.tv_sec;
	_tmp5_ = *inTimeoutInterval;
	_tmp6_ = _tmp5_.m_StartTime;
	_tmp7_ = _tmp6_.tv_sec;
	_tmp8_ = (*self).m_StartTime;
	_tmp9_ = _tmp8_.tv_usec;
	_tmp10_ = *inTimeoutInterval;
	_tmp11_ = _tmp10_.m_StartTime;
	_tmp12_ = _tmp11_.tv_usec;
	b_difference = ((_tmp4_ - _tmp7_) * 1000) + ((_tmp9_ - _tmp12_) / 1000);
	_tmp13_ = (*self).m_FrameCount;
	_tmp14_ = *inTimeoutInterval;
	_tmp15_ = _tmp14_.m_FrameCount;
	result = (gint) (((_tmp13_ + 1) * a_delay) - (((_tmp15_ + 1) * b_delay) + b_difference));
	return result;
}


CCMTimeoutInterval* ccm_timeout_interval_dup (const CCMTimeoutInterval* self) {
	CCMTimeoutInterval* dup;
	dup = g_new0 (CCMTimeoutInterval, 1);
	memcpy (dup, self, sizeof (CCMTimeoutInterval));
	return dup;
}


void ccm_timeout_interval_free (CCMTimeoutInterval* self) {
	g_free (self);
}


GType ccm_timeout_interval_get_type (void) {
	static volatile gsize ccm_timeout_interval_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeout_interval_type_id__volatile)) {
		GType ccm_timeout_interval_type_id;
		ccm_timeout_interval_type_id = g_boxed_type_register_static ("CCMTimeoutInterval", (GBoxedCopyFunc) ccm_timeout_interval_dup, (GBoxedFreeFunc) ccm_timeout_interval_free);
		g_once_init_leave (&ccm_timeout_interval_type_id__volatile, ccm_timeout_interval_type_id);
	}
	return ccm_timeout_interval_type_id__volatile;
}



