/* ccm-timeout.c generated by valac 0.16.0, the Vala compiler
 * generated from ccm-timeout.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * ccm-timeout.vala
 * Copyright (C) Nicolas Bruguier 2007-2011 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <ccm-source.h>
#include <gobject/gvaluecollector.h>


#define CCM_TYPE_TIMEOUT_FLAGS (ccm_timeout_flags_get_type ())

#define CCM_TYPE_TIMEOUT (ccm_timeout_get_type ())
#define CCM_TIMEOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_TIMEOUT, CCMTimeout))
#define CCM_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_TIMEOUT, CCMTimeoutClass))
#define CCM_IS_TIMEOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_TIMEOUT))
#define CCM_IS_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_TIMEOUT))
#define CCM_TIMEOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_TIMEOUT, CCMTimeoutClass))

typedef struct _CCMTimeout CCMTimeout;
typedef struct _CCMTimeoutClass CCMTimeoutClass;
typedef struct _CCMTimeoutPrivate CCMTimeoutPrivate;

#define CCM_TYPE_TIMEOUT_INTERVAL (ccm_timeout_interval_get_type ())
typedef struct _CCMTimeoutInterval CCMTimeoutInterval;
typedef struct _CCMParamSpecTimeout CCMParamSpecTimeout;

typedef enum  {
	CCM_TIMEOUT_FLAGS_NONE = 0,
	CCM_TIMEOUT_FLAGS_READY = 1 << 1,
	CCM_TIMEOUT_FLAGS_MASTER = 1 << 2
} CCMTimeoutFlags;

struct _CCMTimeoutInterval {
	GTimeVal m_StartTime;
	guint m_FrameCount;
	guint m_Fps;
};

typedef gboolean (*CCMTimeoutFunc) (void* inData);
struct _CCMTimeout {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CCMTimeoutPrivate * priv;
	CCMTimeoutInterval interval;
	CCMTimeoutFunc callback;
	void* data;
	GDestroyNotify notify;
};

struct _CCMTimeoutClass {
	GTypeClass parent_class;
	void (*finalize) (CCMTimeout *self);
};

struct _CCMTimeoutPrivate {
	CCMTimeoutFlags m_Flags;
};

struct _CCMParamSpecTimeout {
	GParamSpec parent_instance;
};


static gpointer ccm_timeout_parent_class = NULL;

GType ccm_timeout_flags_get_type (void) G_GNUC_CONST;
gpointer ccm_timeout_ref (gpointer instance);
void ccm_timeout_unref (gpointer instance);
GParamSpec* ccm_param_spec_timeout (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void ccm_value_set_timeout (GValue* value, gpointer v_object);
void ccm_value_take_timeout (GValue* value, gpointer v_object);
gpointer ccm_value_get_timeout (const GValue* value);
GType ccm_timeout_get_type (void) G_GNUC_CONST;
GType ccm_timeout_interval_get_type (void) G_GNUC_CONST;
CCMTimeoutInterval* ccm_timeout_interval_dup (const CCMTimeoutInterval* self);
void ccm_timeout_interval_free (CCMTimeoutInterval* self);
#define CCM_TIMEOUT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CCM_TYPE_TIMEOUT, CCMTimeoutPrivate))
enum  {
	CCM_TIMEOUT_DUMMY_PROPERTY
};
CCMTimeout* ccm_timeout_new (guint inFps);
CCMTimeout* ccm_timeout_construct (GType object_type, guint inFps);
void ccm_timeout_interval_init (CCMTimeoutInterval *self, guint inFps);
gint ccm_timeout_compare (CCMTimeout* inA, CCMTimeout* inB);
gboolean ccm_timeout_get_ready (CCMTimeout* self);
gboolean ccm_timeout_get_master (CCMTimeout* self);
gint ccm_timeout_interval_compare (CCMTimeoutInterval *self, CCMTimeoutInterval* inTimeoutInterval);
gboolean ccm_timeout_prepare (CCMTimeout* self, CCMSource* inSource, gint* outNextTimeout);
gboolean ccm_timeout_interval_prepare (CCMTimeoutInterval *self, GTimeVal* inCurrentTime, gint* outDelay);
void ccm_timeout_set_ready (CCMTimeout* self, gboolean value);
void ccm_timeout_set_master (CCMTimeout* self, gboolean value);
static void ccm_timeout_finalize (CCMTimeout* obj);


GType ccm_timeout_flags_get_type (void) {
	static volatile gsize ccm_timeout_flags_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeout_flags_type_id__volatile)) {
		static const GEnumValue values[] = {{CCM_TIMEOUT_FLAGS_NONE, "CCM_TIMEOUT_FLAGS_NONE", "none"}, {CCM_TIMEOUT_FLAGS_READY, "CCM_TIMEOUT_FLAGS_READY", "ready"}, {CCM_TIMEOUT_FLAGS_MASTER, "CCM_TIMEOUT_FLAGS_MASTER", "master"}, {0, NULL, NULL}};
		GType ccm_timeout_flags_type_id;
		ccm_timeout_flags_type_id = g_enum_register_static ("CCMTimeoutFlags", values);
		g_once_init_leave (&ccm_timeout_flags_type_id__volatile, ccm_timeout_flags_type_id);
	}
	return ccm_timeout_flags_type_id__volatile;
}


CCMTimeout* ccm_timeout_construct (GType object_type, guint inFps) {
	CCMTimeout* self = NULL;
	guint _tmp0_;
	self = (CCMTimeout*) g_type_create_instance (object_type);
	_tmp0_ = inFps;
	ccm_timeout_interval_init (&self->interval, _tmp0_);
	self->priv->m_Flags = CCM_TIMEOUT_FLAGS_NONE;
	return self;
}


CCMTimeout* ccm_timeout_new (guint inFps) {
	return ccm_timeout_construct (CCM_TYPE_TIMEOUT, inFps);
}


gint ccm_timeout_compare (CCMTimeout* inA, CCMTimeout* inB) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	CCMTimeout* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_ = FALSE;
	CCMTimeout* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp15_;
	CCMTimeout* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	CCMTimeout* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	CCMTimeout* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	CCMTimeout* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	CCMTimeout* _tmp28_;
	CCMTimeout* _tmp29_;
	CCMTimeoutInterval _tmp30_;
	gint _tmp31_ = 0;
	g_return_val_if_fail (inA != NULL, 0);
	g_return_val_if_fail (inB != NULL, 0);
	_tmp1_ = inA;
	_tmp2_ = ccm_timeout_get_ready (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		CCMTimeout* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = inA;
		_tmp5_ = ccm_timeout_get_master (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp7_ = _tmp0_;
	if (_tmp7_) {
		result = -1;
		return result;
	}
	_tmp9_ = inB;
	_tmp10_ = ccm_timeout_get_ready (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		CCMTimeout* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp12_ = inB;
		_tmp13_ = ccm_timeout_get_master (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp8_ = _tmp14_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp15_ = _tmp8_;
	if (_tmp15_) {
		result = 1;
		return result;
	}
	_tmp16_ = inA;
	_tmp17_ = ccm_timeout_get_ready (_tmp16_);
	_tmp18_ = _tmp17_;
	if (_tmp18_) {
		result = -1;
		return result;
	}
	_tmp19_ = inB;
	_tmp20_ = ccm_timeout_get_ready (_tmp19_);
	_tmp21_ = _tmp20_;
	if (_tmp21_) {
		result = 1;
		return result;
	}
	_tmp22_ = inA;
	_tmp23_ = ccm_timeout_get_master (_tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_) {
		result = -1;
		return result;
	}
	_tmp25_ = inB;
	_tmp26_ = ccm_timeout_get_master (_tmp25_);
	_tmp27_ = _tmp26_;
	if (_tmp27_) {
		result = 1;
		return result;
	}
	_tmp28_ = inA;
	_tmp29_ = inB;
	_tmp30_ = _tmp29_->interval;
	_tmp31_ = ccm_timeout_interval_compare (&_tmp28_->interval, &_tmp30_);
	result = _tmp31_;
	return result;
}


gboolean ccm_timeout_prepare (CCMTimeout* self, CCMSource* inSource, gint* outNextTimeout) {
	gint _vala_outNextTimeout = 0;
	gboolean result = FALSE;
	GTimeVal now = {0};
	CCMSource* _tmp0_;
	GTimeVal _tmp1_ = {0};
	GTimeVal _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (inSource != NULL, FALSE);
	_tmp0_ = inSource;
	g_source_get_current_time ((GSource*) _tmp0_, &_tmp1_);
	now = _tmp1_;
	_tmp2_ = now;
	_tmp4_ = ccm_timeout_interval_prepare (&self->interval, &_tmp2_, &_tmp3_);
	_vala_outNextTimeout = _tmp3_;
	result = _tmp4_;
	if (outNextTimeout) {
		*outNextTimeout = _vala_outNextTimeout;
	}
	return result;
}


gboolean ccm_timeout_get_ready (CCMTimeout* self) {
	gboolean result;
	CCMTimeoutFlags _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_Flags;
	result = (_tmp0_ & CCM_TIMEOUT_FLAGS_READY) == CCM_TIMEOUT_FLAGS_READY;
	return result;
}


void ccm_timeout_set_ready (CCMTimeout* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_) {
		CCMTimeoutFlags _tmp1_;
		_tmp1_ = self->priv->m_Flags;
		self->priv->m_Flags = _tmp1_ | CCM_TIMEOUT_FLAGS_READY;
	} else {
		CCMTimeoutFlags _tmp2_;
		_tmp2_ = self->priv->m_Flags;
		self->priv->m_Flags = _tmp2_ & (~((gint) CCM_TIMEOUT_FLAGS_READY));
	}
}


gboolean ccm_timeout_get_master (CCMTimeout* self) {
	gboolean result;
	CCMTimeoutFlags _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->m_Flags;
	result = (_tmp0_ & CCM_TIMEOUT_FLAGS_MASTER) == CCM_TIMEOUT_FLAGS_MASTER;
	return result;
}


void ccm_timeout_set_master (CCMTimeout* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_) {
		CCMTimeoutFlags _tmp1_;
		_tmp1_ = self->priv->m_Flags;
		self->priv->m_Flags = _tmp1_ | CCM_TIMEOUT_FLAGS_MASTER;
	} else {
		CCMTimeoutFlags _tmp2_;
		_tmp2_ = self->priv->m_Flags;
		self->priv->m_Flags = _tmp2_ & (~((gint) CCM_TIMEOUT_FLAGS_MASTER));
	}
}


static void ccm_value_timeout_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void ccm_value_timeout_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		ccm_timeout_unref (value->data[0].v_pointer);
	}
}


static void ccm_value_timeout_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = ccm_timeout_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer ccm_value_timeout_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* ccm_value_timeout_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		CCMTimeout* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = ccm_timeout_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* ccm_value_timeout_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	CCMTimeout** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = ccm_timeout_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* ccm_param_spec_timeout (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	CCMParamSpecTimeout* spec;
	g_return_val_if_fail (g_type_is_a (object_type, CCM_TYPE_TIMEOUT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer ccm_value_get_timeout (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CCM_TYPE_TIMEOUT), NULL);
	return value->data[0].v_pointer;
}


void ccm_value_set_timeout (GValue* value, gpointer v_object) {
	CCMTimeout* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CCM_TYPE_TIMEOUT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CCM_TYPE_TIMEOUT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		ccm_timeout_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		ccm_timeout_unref (old);
	}
}


void ccm_value_take_timeout (GValue* value, gpointer v_object) {
	CCMTimeout* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CCM_TYPE_TIMEOUT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CCM_TYPE_TIMEOUT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		ccm_timeout_unref (old);
	}
}


static void ccm_timeout_class_init (CCMTimeoutClass * klass) {
	ccm_timeout_parent_class = g_type_class_peek_parent (klass);
	CCM_TIMEOUT_CLASS (klass)->finalize = ccm_timeout_finalize;
	g_type_class_add_private (klass, sizeof (CCMTimeoutPrivate));
}


static void ccm_timeout_instance_init (CCMTimeout * self) {
	self->priv = CCM_TIMEOUT_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void ccm_timeout_finalize (CCMTimeout* obj) {
	CCMTimeout * self;
	GDestroyNotify _tmp0_;
	self = CCM_TIMEOUT (obj);
	_tmp0_ = self->notify;
	if (_tmp0_ != NULL) {
		GDestroyNotify _tmp1_;
		void* _tmp2_;
		_tmp1_ = self->notify;
		_tmp2_ = self->data;
		_tmp1_ (_tmp2_);
	}
}


GType ccm_timeout_get_type (void) {
	static volatile gsize ccm_timeout_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeout_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { ccm_value_timeout_init, ccm_value_timeout_free_value, ccm_value_timeout_copy_value, ccm_value_timeout_peek_pointer, "p", ccm_value_timeout_collect_value, "p", ccm_value_timeout_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (CCMTimeoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ccm_timeout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CCMTimeout), 0, (GInstanceInitFunc) ccm_timeout_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType ccm_timeout_type_id;
		ccm_timeout_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CCMTimeout", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&ccm_timeout_type_id__volatile, ccm_timeout_type_id);
	}
	return ccm_timeout_type_id__volatile;
}


gpointer ccm_timeout_ref (gpointer instance) {
	CCMTimeout* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void ccm_timeout_unref (gpointer instance) {
	CCMTimeout* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CCM_TIMEOUT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



