/* ccm-automate-dialog.c generated by valac 0.16.0, the Vala compiler
 * generated from ccm-automate-dialog.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * ccm-automate-dialog.vala
 * Copyright (C) Nicolas Bruguier 2007-2011 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "gdk/gdkx.h"
#include <gdk/gdk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <ccm.h>
#include <ccm-screen.h>
#include <ccm-timeline.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <ccm-cairo-utils.h>
#include <ccm-window.h>
#include <ccm-window-plugin.h>
#include <stdio.h>
#include <ccm-debug.h>


#define CCM_TYPE_AUTOMATE_DIALOG (ccm_automate_dialog_get_type ())
#define CCM_AUTOMATE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialog))
#define CCM_AUTOMATE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialogClass))
#define CCM_IS_AUTOMATE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_AUTOMATE_DIALOG))
#define CCM_IS_AUTOMATE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_AUTOMATE_DIALOG))
#define CCM_AUTOMATE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialogClass))

typedef struct _CCMAutomateDialog CCMAutomateDialog;
typedef struct _CCMAutomateDialogClass CCMAutomateDialogClass;
typedef struct _CCMAutomateDialogPrivate CCMAutomateDialogPrivate;

#define CCM_TYPE_STORY_BOARD (ccm_story_board_get_type ())
#define CCM_STORY_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_STORY_BOARD, CCMStoryBoard))
#define CCM_STORY_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_STORY_BOARD, CCMStoryBoardClass))
#define CCM_IS_STORY_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_STORY_BOARD))
#define CCM_IS_STORY_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_STORY_BOARD))
#define CCM_STORY_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_STORY_BOARD, CCMStoryBoardClass))

typedef struct _CCMStoryBoard CCMStoryBoard;
typedef struct _CCMStoryBoardClass CCMStoryBoardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _CCMAutomateDialog {
	GObject parent_instance;
	CCMAutomateDialogPrivate * priv;
};

struct _CCMAutomateDialogClass {
	GObjectClass parent_class;
};

struct _CCMAutomateDialogPrivate {
	CCMScreen* screen;
	CCMTimeline* timeline;
	GtkWindow* main;
	GtkWidget* close;
	GtkImage* close_image;
	GtkCheckButton* hint_motion;
	CCMStoryBoard* story_board;
};


static gpointer ccm_automate_dialog_parent_class = NULL;
static GType ccm_automate_dialog_type_id = 0;

GType ccm_automate_dialog_get_type (void) G_GNUC_CONST;
GType ccm_automate_dialog_register_type (GTypeModule * module);
GType ccm_story_board_get_type (void) G_GNUC_CONST;
GType ccm_story_board_register_type (GTypeModule * module);
#define CCM_AUTOMATE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialogPrivate))
enum  {
	CCM_AUTOMATE_DIALOG_DUMMY_PROPERTY
};
#define CCM_AUTOMATE_DIALOG_UI_FILE UI_DIR "/ccm-automate.ui"
CCMAutomateDialog* ccm_automate_dialog_new (CCMScreen* screen);
CCMAutomateDialog* ccm_automate_dialog_construct (GType object_type, CCMScreen* screen);
static void ccm_automate_dialog_on_new_frame (CCMAutomateDialog* self, CCMTimeline* timeline, gint num_frame);
static void _ccm_automate_dialog_on_new_frame_ccm_timeline_new_frame (CCMTimeline* _sender, gint inNumFrame, gpointer self);
static void ccm_automate_dialog_on_completed (CCMAutomateDialog* self, CCMTimeline* timeline);
static void _ccm_automate_dialog_on_completed_ccm_timeline_completed (CCMTimeline* _sender, gpointer self);
static void ccm_automate_dialog_construct_ui (CCMAutomateDialog* self);
static void ccm_automate_dialog_on_realize (CCMAutomateDialog* self, GtkWidget* widget);
static gboolean ccm_automate_dialog_on_expose_event (CCMAutomateDialog* self, GtkWidget* widget, GdkEventExpose* event);
static gboolean ccm_automate_dialog_on_close (CCMAutomateDialog* self, GtkWidget* widget, GdkEventButton* event);
static void ccm_automate_dialog_on_record_clicked (CCMAutomateDialog* self, GtkButton* button);
CCMStoryBoard* ccm_story_board_new (CCMScreen* screen, const gchar* name, GList* ignore);
CCMStoryBoard* ccm_story_board_construct (GType object_type, CCMScreen* screen, const gchar* name, GList* ignore);
void ccm_story_board_set_hint_motion (CCMStoryBoard* self, gboolean value);
static void ccm_automate_dialog_on_stop_clicked (CCMAutomateDialog* self, GtkButton* button);
gchar* ccm_story_board_to_string (CCMStoryBoard* self, const gchar* format);
static void _ccm_automate_dialog_on_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self);
static gboolean _ccm_automate_dialog_on_expose_event_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self);
static gboolean _ccm_automate_dialog_on_close_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void _ccm_automate_dialog_on_record_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _ccm_automate_dialog_on_stop_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
void ccm_automate_dialog_show (CCMAutomateDialog* self);
void ccm_automate_dialog_hide (CCMAutomateDialog* self);
static void ccm_automate_dialog_finalize (GObject* obj);


static void _ccm_automate_dialog_on_new_frame_ccm_timeline_new_frame (CCMTimeline* _sender, gint inNumFrame, gpointer self) {
	ccm_automate_dialog_on_new_frame (self, _sender, inNumFrame);
}


static void _ccm_automate_dialog_on_completed_ccm_timeline_completed (CCMTimeline* _sender, gpointer self) {
	ccm_automate_dialog_on_completed (self, _sender);
}


CCMAutomateDialog* ccm_automate_dialog_construct (GType object_type, CCMScreen* screen) {
	CCMAutomateDialog * self = NULL;
	CCMScreen* _tmp0_;
	CCMTimeline* _tmp1_;
	CCMTimeline* _tmp2_;
	CCMTimeline* _tmp3_;
	CCMTimeline* _tmp4_;
	g_return_val_if_fail (screen != NULL, NULL);
	self = (CCMAutomateDialog*) g_object_new (object_type, NULL);
	_tmp0_ = screen;
	self->priv->screen = _tmp0_;
	_tmp1_ = ccm_timeline_new ((guint) 10, (guint) 60);
	_g_object_unref0 (self->priv->timeline);
	self->priv->timeline = _tmp1_;
	_tmp2_ = self->priv->timeline;
	ccm_timeline_set_direction (_tmp2_, CCM_TIMELINE_DIRECTION_BACKWARD);
	_tmp3_ = self->priv->timeline;
	g_signal_connect_object (_tmp3_, "new-frame", (GCallback) _ccm_automate_dialog_on_new_frame_ccm_timeline_new_frame, self, 0);
	_tmp4_ = self->priv->timeline;
	g_signal_connect_object (_tmp4_, "completed", (GCallback) _ccm_automate_dialog_on_completed_ccm_timeline_completed, self, 0);
	ccm_automate_dialog_construct_ui (self);
	return self;
}


CCMAutomateDialog* ccm_automate_dialog_new (CCMScreen* screen) {
	return ccm_automate_dialog_construct (CCM_TYPE_AUTOMATE_DIALOG, screen);
}


static void ccm_automate_dialog_on_new_frame (CCMAutomateDialog* self, CCMTimeline* timeline, gint num_frame) {
	gint width = 0;
	gint height = 0;
	gint x = 0;
	gint y = 0;
	GtkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GtkWindow* _tmp4_;
	GdkWindow* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_;
	GtkWidget* _tmp9_;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	GtkWindow* _tmp12_;
	gint _tmp13_;
	CCMTimeline* _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeline != NULL);
	_tmp0_ = self->priv->main;
	_tmp1_ = ((GtkWidget*) _tmp0_)->window;
	gdk_window_get_origin (_tmp1_, &_tmp2_, &_tmp3_);
	x = _tmp2_;
	y = _tmp3_;
	_tmp4_ = self->priv->main;
	_tmp5_ = ((GtkWidget*) _tmp4_)->window;
	gdk_drawable_get_size ((GdkDrawable*) _tmp5_, &_tmp6_, &_tmp7_);
	width = _tmp6_;
	height = _tmp7_;
	_tmp8_ = height;
	_tmp9_ = self->priv->close;
	_tmp10_ = _tmp9_->allocation;
	_tmp11_ = _tmp10_.height;
	height = _tmp8_ - _tmp11_;
	_tmp12_ = self->priv->main;
	_tmp13_ = height;
	_tmp14_ = timeline;
	_tmp15_ = ccm_timeline_get_progress (_tmp14_);
	_tmp16_ = _tmp15_;
	gtk_window_move (_tmp12_, x, -((gint) (((gdouble) _tmp13_) * _tmp16_)));
}


static void ccm_automate_dialog_on_completed (CCMAutomateDialog* self, CCMTimeline* timeline) {
	gchar* stock = NULL;
	CCMTimeline* _tmp0_;
	CCMTimelineDirection _tmp1_;
	CCMTimelineDirection _tmp2_;
	GtkImage* _tmp5_;
	const gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeline != NULL);
	_tmp0_ = timeline;
	_tmp1_ = ccm_timeline_get_direction (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (GTK_STOCK_GO_DOWN);
		_g_free0 (stock);
		stock = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (GTK_STOCK_GO_UP);
		_g_free0 (stock);
		stock = _tmp4_;
	}
	_tmp5_ = self->priv->close_image;
	_tmp6_ = stock;
	gtk_image_set_from_stock (_tmp5_, _tmp6_, GTK_ICON_SIZE_BUTTON);
	_g_free0 (stock);
}


static void ccm_automate_dialog_on_realize (CCMAutomateDialog* self, GtkWidget* widget) {
	gint width = 0;
	gint height = 0;
	GdkAtom _tmp0_ = {0};
	GdkAtom atom_enable;
	guchar* _tmp1_ = NULL;
	guchar* enable;
	gint enable_length1;
	gint _enable_size_;
	GtkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	Atom _tmp4_ = {0};
	GdkAtom _tmp5_ = {0};
	GtkWindow* _tmp6_;
	GdkWindow* _tmp7_;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	GtkWindow* _tmp10_;
	GdkWindow* _tmp11_;
	GtkWindow* _tmp12_;
	CCMScreen* _tmp13_;
	Screen* _tmp14_ = NULL;
	gint _tmp15_;
	GdkPixmap* _tmp16_;
	GdkPixmap* pixmap;
	cairo_t* _tmp17_ = NULL;
	cairo_t* ctx;
	GtkWidget* _tmp18_;
	GtkAllocation _tmp19_;
	gint _tmp20_;
	GtkWidget* _tmp21_;
	GtkAllocation _tmp22_;
	gint _tmp23_;
	cairo_surface_t* _tmp24_ = NULL;
	GtkWidget* _tmp25_;
	GdkWindow* _tmp26_;
	GtkWidget* _tmp27_;
	GdkWindow* _tmp28_;
	GtkWidget* _tmp29_;
	GdkWindow* _tmp30_;
	GtkWidget* _tmp31_;
	GdkWindow* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gdk_atom_intern_static_string ("_CCM_SHADOW_ENABLED");
	atom_enable = _tmp0_;
	_tmp1_ = g_new0 (guchar, 1);
	_tmp1_[0] = (guchar) 1;
	enable = _tmp1_;
	enable_length1 = 1;
	_enable_size_ = enable_length1;
	_tmp2_ = self->priv->main;
	_tmp3_ = ((GtkWidget*) _tmp2_)->window;
	_tmp4_ = gdk_x11_get_xatom_by_name ("CARDINAL");
	_tmp5_ = gdk_x11_xatom_to_atom (_tmp4_);
	gdk_property_change (_tmp3_, atom_enable, _tmp5_, 32, GDK_PROP_MODE_REPLACE, enable, 1);
	_tmp6_ = self->priv->main;
	_tmp7_ = ((GtkWidget*) _tmp6_)->window;
	gdk_drawable_get_size ((GdkDrawable*) _tmp7_, &_tmp8_, &_tmp9_);
	width = _tmp8_;
	height = _tmp9_;
	_tmp10_ = self->priv->main;
	_tmp11_ = ((GtkWidget*) _tmp10_)->window;
	gdk_window_set_override_redirect (_tmp11_, TRUE);
	_tmp12_ = self->priv->main;
	_tmp13_ = self->priv->screen;
	_tmp14_ = ccm_screen_get_xscreen (_tmp13_);
	_tmp15_ = _tmp14_->width;
	gtk_window_move (_tmp12_, (_tmp15_ / 2) - (width / 2), 0);
	_tmp16_ = gdk_pixmap_new (NULL, width, height, 1);
	pixmap = _tmp16_;
	_tmp17_ = gdk_cairo_create ((GdkDrawable*) pixmap);
	ctx = _tmp17_;
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
	cairo_set_source_rgba (ctx, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
	cairo_paint (ctx);
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
	cairo_translate (ctx, (gdouble) (width / 2), (gdouble) (height / 2));
	cairo_rotate (ctx, -M_PI);
	cairo_translate (ctx, (gdouble) ((-width) / 2), (gdouble) ((-height) / 2));
	cairo_set_source_rgba (ctx, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
	_tmp18_ = self->priv->close;
	_tmp19_ = _tmp18_->allocation;
	_tmp20_ = _tmp19_.width;
	_tmp21_ = self->priv->close;
	_tmp22_ = _tmp21_->allocation;
	_tmp23_ = _tmp22_.height;
	cairo_notebook_page_round ((cairo_t*) ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) 0, (gdouble) _tmp20_, (gdouble) _tmp23_, 6);
	cairo_fill (ctx);
	_tmp24_ = cairo_get_target (ctx);
	cairo_surface_finish (_tmp24_);
	_tmp25_ = widget;
	_tmp26_ = _tmp25_->window;
	gdk_window_shape_combine_mask (_tmp26_, (GdkBitmap*) NULL, 0, 0);
	_tmp27_ = widget;
	_tmp28_ = _tmp27_->window;
	gdk_window_input_shape_combine_mask (_tmp28_, (GdkBitmap*) NULL, 0, 0);
	_tmp29_ = widget;
	_tmp30_ = _tmp29_->window;
	gdk_window_shape_combine_mask (_tmp30_, (GdkBitmap*) pixmap, 0, 0);
	_tmp31_ = widget;
	_tmp32_ = _tmp31_->window;
	gdk_window_input_shape_combine_mask (_tmp32_, (GdkBitmap*) pixmap, 0, 0);
	_cairo_destroy0 (ctx);
	_g_object_unref0 (pixmap);
	enable = (g_free (enable), NULL);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean ccm_automate_dialog_on_expose_event (CCMAutomateDialog* self, GtkWidget* widget, GdkEventExpose* event) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	GdkWindow* _tmp1_;
	cairo_t* _tmp2_ = NULL;
	cairo_t* ctx;
	gint width = 0;
	gint height = 0;
	GtkWidget* _tmp3_;
	GdkWindow* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GtkWidget* _tmp7_;
	GtkStyle* _tmp8_;
	GtkStyle* _tmp9_;
	GdkColor* _tmp10_;
	gint _tmp10__length1;
	GdkColor _tmp11_;
	guint16 _tmp12_;
	GtkWidget* _tmp13_;
	GtkStyle* _tmp14_;
	GtkStyle* _tmp15_;
	GdkColor* _tmp16_;
	gint _tmp16__length1;
	GdkColor _tmp17_;
	guint16 _tmp18_;
	GtkWidget* _tmp19_;
	GtkStyle* _tmp20_;
	GtkStyle* _tmp21_;
	GdkColor* _tmp22_;
	gint _tmp22__length1;
	GdkColor _tmp23_;
	guint16 _tmp24_;
	GtkWidget* _tmp25_;
	GtkAllocation _tmp26_;
	gint _tmp27_;
	GtkWidget* _tmp28_;
	GtkAllocation _tmp29_;
	gint _tmp30_;
	GtkWidget* _tmp31_;
	GtkStyle* _tmp32_;
	GtkStyle* _tmp33_;
	GdkColor* _tmp34_;
	gint _tmp34__length1;
	GdkColor _tmp35_;
	guint16 _tmp36_;
	GtkWidget* _tmp37_;
	GtkStyle* _tmp38_;
	GtkStyle* _tmp39_;
	GdkColor* _tmp40_;
	gint _tmp40__length1;
	GdkColor _tmp41_;
	guint16 _tmp42_;
	GtkWidget* _tmp43_;
	GtkStyle* _tmp44_;
	GtkStyle* _tmp45_;
	GdkColor* _tmp46_;
	gint _tmp46__length1;
	GdkColor _tmp47_;
	guint16 _tmp48_;
	GtkWidget* _tmp49_;
	GtkAllocation _tmp50_;
	gint _tmp51_;
	GtkWidget* _tmp52_;
	GtkAllocation _tmp53_;
	gint _tmp54_;
	GtkWidget* _tmp55_;
	GtkWidget* _tmp56_ = NULL;
	GtkWidget* _tmp57_;
	GtkWidget* child;
	GtkWidget* _tmp58_;
	GdkEventExpose _tmp59_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = widget;
	_tmp1_ = _tmp0_->window;
	_tmp2_ = gdk_cairo_create ((GdkDrawable*) _tmp1_);
	ctx = _tmp2_;
	_tmp3_ = widget;
	_tmp4_ = _tmp3_->window;
	gdk_drawable_get_size ((GdkDrawable*) _tmp4_, &_tmp5_, &_tmp6_);
	width = _tmp5_;
	height = _tmp6_;
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
	cairo_paint (ctx);
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
	cairo_translate (ctx, (gdouble) (width / 2), (gdouble) (height / 2));
	cairo_rotate (ctx, -M_PI);
	cairo_translate (ctx, (gdouble) ((-width) / 2), (gdouble) ((-height) / 2));
	_tmp7_ = widget;
	_tmp8_ = gtk_widget_get_style (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_->bg;
	_tmp10__length1 = -1;
	_tmp11_ = _tmp10_[GTK_STATE_NORMAL];
	_tmp12_ = _tmp11_.red;
	_tmp13_ = widget;
	_tmp14_ = gtk_widget_get_style (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = _tmp15_->bg;
	_tmp16__length1 = -1;
	_tmp17_ = _tmp16_[GTK_STATE_NORMAL];
	_tmp18_ = _tmp17_.green;
	_tmp19_ = widget;
	_tmp20_ = gtk_widget_get_style (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = _tmp21_->bg;
	_tmp22__length1 = -1;
	_tmp23_ = _tmp22_[GTK_STATE_NORMAL];
	_tmp24_ = _tmp23_.blue;
	cairo_set_source_rgba (ctx, ((gdouble) _tmp12_) / 65535, ((gdouble) _tmp18_) / 65535, ((gdouble) _tmp24_) / 65535, 0.85);
	_tmp25_ = self->priv->close;
	_tmp26_ = _tmp25_->allocation;
	_tmp27_ = _tmp26_.width;
	_tmp28_ = self->priv->close;
	_tmp29_ = _tmp28_->allocation;
	_tmp30_ = _tmp29_.height;
	cairo_notebook_page_round ((cairo_t*) ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) 0, (gdouble) _tmp27_, (gdouble) _tmp30_, 6);
	cairo_fill (ctx);
	_tmp31_ = widget;
	_tmp32_ = gtk_widget_get_style (_tmp31_);
	_tmp33_ = _tmp32_;
	_tmp34_ = _tmp33_->bg;
	_tmp34__length1 = -1;
	_tmp35_ = _tmp34_[GTK_STATE_SELECTED];
	_tmp36_ = _tmp35_.red;
	_tmp37_ = widget;
	_tmp38_ = gtk_widget_get_style (_tmp37_);
	_tmp39_ = _tmp38_;
	_tmp40_ = _tmp39_->bg;
	_tmp40__length1 = -1;
	_tmp41_ = _tmp40_[GTK_STATE_SELECTED];
	_tmp42_ = _tmp41_.green;
	_tmp43_ = widget;
	_tmp44_ = gtk_widget_get_style (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _tmp45_->bg;
	_tmp46__length1 = -1;
	_tmp47_ = _tmp46_[GTK_STATE_SELECTED];
	_tmp48_ = _tmp47_.blue;
	cairo_set_source_rgba (ctx, ((gdouble) _tmp36_) / 65535, ((gdouble) _tmp42_) / 65535, ((gdouble) _tmp48_) / 65535, (gdouble) 1);
	_tmp49_ = self->priv->close;
	_tmp50_ = _tmp49_->allocation;
	_tmp51_ = _tmp50_.width;
	_tmp52_ = self->priv->close;
	_tmp53_ = _tmp52_->allocation;
	_tmp54_ = _tmp53_.height;
	cairo_notebook_page_round ((cairo_t*) ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) 0, (gdouble) _tmp51_, (gdouble) _tmp54_, 6);
	cairo_stroke (ctx);
	_tmp55_ = widget;
	_tmp56_ = gtk_bin_get_child ((GtkBin*) GTK_WINDOW (_tmp55_));
	_tmp57_ = _g_object_ref0 (_tmp56_);
	child = _tmp57_;
	_tmp58_ = widget;
	_tmp59_ = *event;
	gtk_container_propagate_expose (GTK_CONTAINER (_tmp58_), child, &_tmp59_);
	result = TRUE;
	_g_object_unref0 (child);
	_cairo_destroy0 (ctx);
	return result;
}


static gboolean ccm_automate_dialog_on_close (CCMAutomateDialog* self, GtkWidget* widget, GdkEventButton* event) {
	gboolean result = FALSE;
	CCMTimeline* _tmp0_;
	CCMTimelineDirection _tmp1_;
	CCMTimelineDirection _tmp2_;
	CCMTimeline* _tmp5_;
	CCMTimeline* _tmp6_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->timeline;
	_tmp1_ = ccm_timeline_get_direction (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		CCMTimeline* _tmp3_;
		_tmp3_ = self->priv->timeline;
		ccm_timeline_set_direction (_tmp3_, CCM_TIMELINE_DIRECTION_BACKWARD);
	} else {
		CCMTimeline* _tmp4_;
		_tmp4_ = self->priv->timeline;
		ccm_timeline_set_direction (_tmp4_, CCM_TIMELINE_DIRECTION_FORWARD);
	}
	_tmp5_ = self->priv->timeline;
	ccm_timeline_stop (_tmp5_);
	_tmp6_ = self->priv->timeline;
	ccm_timeline_start (_tmp6_);
	result = FALSE;
	return result;
}


static void ccm_automate_dialog_on_record_clicked (CCMAutomateDialog* self, GtkButton* button) {
	GtkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	Window _tmp2_ = 0;
	Window xwindow;
	GList* ignore;
	CCMScreen* _tmp3_;
	CCMWindow* _tmp4_ = NULL;
	CCMWindow* window;
	CCMScreen* _tmp5_;
	CCMStoryBoard* _tmp6_;
	CCMStoryBoard* _tmp7_;
	GtkCheckButton* _tmp8_;
	gboolean _tmp9_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	_tmp0_ = self->priv->main;
	_tmp1_ = ((GtkWidget*) _tmp0_)->window;
	_tmp2_ = GDK_WINDOW_XWINDOW (_tmp1_);
	xwindow = _tmp2_;
	ignore = NULL;
	_tmp3_ = self->priv->screen;
	_tmp4_ = ccm_screen_find_window (_tmp3_, xwindow);
	window = _tmp4_;
	ignore = g_list_append (ignore, window);
	_tmp5_ = self->priv->screen;
	_tmp6_ = ccm_story_board_new (_tmp5_, "test", ignore);
	_g_object_unref0 (self->priv->story_board);
	self->priv->story_board = _tmp6_;
	_tmp7_ = self->priv->story_board;
	_tmp8_ = self->priv->hint_motion;
	_tmp9_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_);
	ccm_story_board_set_hint_motion (_tmp7_, _tmp9_);
	_g_list_free0 (ignore);
}


static void ccm_automate_dialog_on_stop_clicked (CCMAutomateDialog* self, GtkButton* button) {
	CCMStoryBoard* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	_tmp0_ = self->priv->story_board;
	if (_tmp0_ != NULL) {
		FILE* _tmp1_;
		CCMStoryBoard* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp1_ = stdout;
		_tmp2_ = self->priv->story_board;
		_tmp3_ = ccm_story_board_to_string (_tmp2_, "%ccmsb");
		_tmp4_ = _tmp3_;
		fprintf (_tmp1_, "%s", _tmp4_);
		_g_free0 (_tmp4_);
	}
	_g_object_unref0 (self->priv->story_board);
	self->priv->story_board = NULL;
}


static void _ccm_automate_dialog_on_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self) {
	ccm_automate_dialog_on_realize (self, _sender);
}


static gboolean _ccm_automate_dialog_on_expose_event_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self) {
	gboolean result;
	result = ccm_automate_dialog_on_expose_event (self, _sender, event);
	return result;
}


static gboolean _ccm_automate_dialog_on_close_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = ccm_automate_dialog_on_close (self, _sender, event);
	return result;
}


static void _ccm_automate_dialog_on_record_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	ccm_automate_dialog_on_record_clicked (self, _sender);
}


static void _ccm_automate_dialog_on_stop_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	ccm_automate_dialog_on_stop_clicked (self, _sender);
}


static void ccm_automate_dialog_construct_ui (CCMAutomateDialog* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GtkBuilder* _tmp0_;
		GtkBuilder* builder;
		GObject* _tmp1_ = NULL;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
		GdkScreen* _tmp4_ = NULL;
		GdkScreen* _tmp5_;
		GdkScreen* screen;
		GdkScreen* _tmp6_;
		GdkColormap* _tmp7_ = NULL;
		GdkColormap* _tmp8_;
		GdkColormap* colormap;
		GtkWindow* _tmp9_;
		GdkColormap* _tmp10_;
		GtkWindow* _tmp11_;
		GtkWindow* _tmp12_;
		GObject* _tmp13_ = NULL;
		GtkWidget* _tmp14_;
		GtkWidget* _tmp15_;
		GObject* _tmp16_ = NULL;
		GtkImage* _tmp17_;
		GObject* _tmp18_ = NULL;
		GtkButton* _tmp19_;
		GtkButton* record;
		GtkButton* _tmp20_;
		GObject* _tmp21_ = NULL;
		GtkButton* _tmp22_;
		GtkButton* stop;
		GtkButton* _tmp23_;
		GObject* _tmp24_ = NULL;
		GtkCheckButton* _tmp25_;
		_tmp0_ = gtk_builder_new ();
		builder = _tmp0_;
		gtk_builder_add_from_file (builder, CCM_AUTOMATE_DIALOG_UI_FILE, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (builder);
			goto __catch2_g_error;
		}
		_tmp1_ = gtk_builder_get_object (builder, "main");
		_tmp2_ = _g_object_ref0 (GTK_IS_WINDOW (_tmp1_) ? ((GtkWindow*) _tmp1_) : NULL);
		_g_object_unref0 (self->priv->main);
		self->priv->main = _tmp2_;
		_tmp3_ = self->priv->main;
		gtk_window_set_keep_above (_tmp3_, TRUE);
		_tmp4_ = gdk_screen_get_default ();
		_tmp5_ = _g_object_ref0 (_tmp4_);
		screen = _tmp5_;
		_tmp6_ = screen;
		_tmp7_ = gdk_screen_get_rgba_colormap (_tmp6_);
		_tmp8_ = _g_object_ref0 (_tmp7_);
		colormap = _tmp8_;
		_tmp9_ = self->priv->main;
		_tmp10_ = colormap;
		gtk_widget_set_colormap ((GtkWidget*) _tmp9_, _tmp10_);
		_tmp11_ = self->priv->main;
		g_signal_connect_object (GTK_WIDGET (_tmp11_), "realize", (GCallback) _ccm_automate_dialog_on_realize_gtk_widget_realize, self, 0);
		_tmp12_ = self->priv->main;
		g_signal_connect_object (GTK_WIDGET (_tmp12_), "expose-event", (GCallback) _ccm_automate_dialog_on_expose_event_gtk_widget_expose_event, self, 0);
		_tmp13_ = gtk_builder_get_object (builder, "close");
		_tmp14_ = _g_object_ref0 (GTK_IS_WIDGET (_tmp13_) ? ((GtkWidget*) _tmp13_) : NULL);
		_g_object_unref0 (self->priv->close);
		self->priv->close = _tmp14_;
		_tmp15_ = self->priv->close;
		g_signal_connect_object (_tmp15_, "button-press-event", (GCallback) _ccm_automate_dialog_on_close_gtk_widget_button_press_event, self, 0);
		_tmp16_ = gtk_builder_get_object (builder, "close_image");
		_tmp17_ = _g_object_ref0 (GTK_IS_IMAGE (_tmp16_) ? ((GtkImage*) _tmp16_) : NULL);
		_g_object_unref0 (self->priv->close_image);
		self->priv->close_image = _tmp17_;
		_tmp18_ = gtk_builder_get_object (builder, "record");
		_tmp19_ = _g_object_ref0 (GTK_IS_BUTTON (_tmp18_) ? ((GtkButton*) _tmp18_) : NULL);
		record = _tmp19_;
		_tmp20_ = record;
		g_signal_connect_object (_tmp20_, "clicked", (GCallback) _ccm_automate_dialog_on_record_clicked_gtk_button_clicked, self, 0);
		_tmp21_ = gtk_builder_get_object (builder, "stop");
		_tmp22_ = _g_object_ref0 (GTK_IS_BUTTON (_tmp21_) ? ((GtkButton*) _tmp21_) : NULL);
		stop = _tmp22_;
		_tmp23_ = stop;
		g_signal_connect_object (_tmp23_, "clicked", (GCallback) _ccm_automate_dialog_on_stop_clicked_gtk_button_clicked, self, 0);
		_tmp24_ = gtk_builder_get_object (builder, "hint_motion");
		_tmp25_ = _g_object_ref0 (GTK_IS_CHECK_BUTTON (_tmp24_) ? ((GtkCheckButton*) _tmp24_) : NULL);
		_g_object_unref0 (self->priv->hint_motion);
		self->priv->hint_motion = _tmp25_;
		_g_object_unref0 (stop);
		_g_object_unref0 (record);
		_g_object_unref0 (colormap);
		_g_object_unref0 (screen);
		_g_object_unref0 (builder);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* ex = NULL;
		GError* _tmp26_;
		const gchar* _tmp27_;
		ex = _inner_error_;
		_inner_error_ = NULL;
		_tmp26_ = ex;
		_tmp27_ = _tmp26_->message;
		ccm_log ("Error on create automate dialog: %s", _tmp27_, NULL);
		_g_error_free0 (ex);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void ccm_automate_dialog_show (CCMAutomateDialog* self) {
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main;
	gtk_widget_show ((GtkWidget*) _tmp0_);
}


void ccm_automate_dialog_hide (CCMAutomateDialog* self) {
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
}


static void ccm_automate_dialog_class_init (CCMAutomateDialogClass * klass) {
	ccm_automate_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CCMAutomateDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = ccm_automate_dialog_finalize;
}


static void ccm_automate_dialog_instance_init (CCMAutomateDialog * self) {
	self->priv = CCM_AUTOMATE_DIALOG_GET_PRIVATE (self);
}


static void ccm_automate_dialog_finalize (GObject* obj) {
	CCMAutomateDialog * self;
	GtkWindow* _tmp0_;
	self = CCM_AUTOMATE_DIALOG (obj);
	_tmp0_ = self->priv->main;
	gtk_object_destroy ((GtkObject*) _tmp0_);
	_g_object_unref0 (self->priv->timeline);
	_g_object_unref0 (self->priv->main);
	_g_object_unref0 (self->priv->close);
	_g_object_unref0 (self->priv->close_image);
	_g_object_unref0 (self->priv->hint_motion);
	_g_object_unref0 (self->priv->story_board);
	G_OBJECT_CLASS (ccm_automate_dialog_parent_class)->finalize (obj);
}


GType ccm_automate_dialog_get_type (void) {
	return ccm_automate_dialog_type_id;
}


GType ccm_automate_dialog_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (CCMAutomateDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ccm_automate_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CCMAutomateDialog), 0, (GInstanceInitFunc) ccm_automate_dialog_instance_init, NULL };
	ccm_automate_dialog_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "CCMAutomateDialog", &g_define_type_info, 0);
	return ccm_automate_dialog_type_id;
}



